#include <stdio.h>
#include <stdlib.h>

 void count(int i,
                  int j,
                  int color);

 void countlib(int m,
                     int n,
                     int color);

 void endgame(void);

 void eval(int color);

 void examboard(int color);

 int getij(char move[],
                 int *i,
                 int *j);

 unsigned int findcolor(int i,
                              int j);

 int findnextmove(int m,
                        int n,
                        int *i,
                        int *j,
                        int *val,
                        int minlib);

 int findopen(int m,
                    int n,
                    int i[],
                    int j[],
                    int color,
                    int minlib,
                    int *ct);

 int findpatn(int *i,
                    int *j,
                    int *val);

 int findsaver(int *i,
                     int *j,
                     int *val);

 int findwinner(int *i,
                      int *j,
                      int *val);

 int fioe(int i,
                int j);

 void genmove(int *i,
                    int *j);

 void getmove(char move[],
                    int *i,
                    int *j);

 void initmark(void);

 int matchpat(int m,
                    int n,
                    int *i,
                    int *j,
                    int *val);

 int opening(int *i,
                   int *j,
                   int *cnd,
                   int type);

 int openregion(int i1,
                      int j1,
                      int i2,
                      int j2);

 void showboard(void);

 void showinst(void);

 void sethand(int i);

 int suicide(int i,
                   int j); 


/* definitions */

#define EMPTY 0
#define WHITE 1
#define BLACK 2 

//
//THE FOLLOWING IS GNUGO STUFF
//---------------------------------------------------------------------------------------------

unsigned char p[19][19];  /* go board */
unsigned char l[19][19];  /* liberty of current color */
unsigned char ma[19][19]; /* working matrix for marking */
unsigned char ml[19][19]; /* working matrix for marking */
int mymove, umove;        /* computer color, opponent color */
int lib;                  /* current stone liberty */
int play;                 /* game state */
int pass;                 /* pass indicator */
int mik, mjk;             /* location of computer stone captured */
int uik, ujk;             /* location of opponent stone captured */
int mk, uk;               /* no. of stones captured by computer and oppoent */
int opn[9];               /* opening pattern flag */

int handicap=0;           //handicap inicial
int i=0,j=0;

/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*-----------------------------
  patterns.h -- Move patterns
-----------------------------*/

#define PATNO 24
#define MAXPC 16

/* pattern x, y coor and attribute */
struct patval {int x, y, att;};
/* att = 0 - empty,
         1 - your piece,
         2 - my piece,
         3 - my next move
         4 - empty on edge,
         5 - your piece on edge,
         6 - my piece on edge
*/
struct pattern {
                struct patval patn[MAXPC];   /* pattern */
                int patlen;   /* number of pieces in pattern */
                int trfno;    /* no. of transformation */
                int patwt;    /* pattern value */
               };

static struct pattern pat[PATNO] = {
/*
   pattern 0: 232   connect if invaded
	      010
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, 3},
     {1, 1, 1},
     {2, 0, 2},
     {2, 1, EMPTY}}, 6, 4, 82},
/*
   pattern 1: 230   connect if invaded
	      012
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, 3},
     {1, 1, 1},
     {2, 0, EMPTY},
     {2, 1, 2}}, 6, 8, 82},
/*
   pattern 2: 212   try to attack
	      030
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, 1},
     {1, 1, 3},
     {2, 0, 2},
     {2, 1, EMPTY}}, 6, 4, 82},
/*
   pattern 3: 2302   connect if invaded
	      0100
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, 3},
     {1, 1, 1},
     {2, 0, EMPTY},
     {2, 1, EMPTY},
     {3, 0, 2},
     {3, 1, EMPTY}},8, 8, 83},
/*
   pattern 4: 20302   connect if invaded
	      00100
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, EMPTY},
     {1, 1, EMPTY},
     {2, 0, 3},
     {2, 1, 1},
     {3, 0, EMPTY},
     {3, 1, EMPTY},
     {4, 0, 2},
     {4, 1, EMPTY}}, 10, 4, 84},
/*
   pattern 5: 203   form eye to protect
	      021
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, EMPTY},
     {1, 1, 2},
     {2, 0, 3},
     {2, 1, 1}}, 6, 8, 82},
/*
   pattern 6: 202    form eye to protect
	      031
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, EMPTY},
     {1, 1, 3},
     {2, 0, 2},
     {2, 1, 1}}, 6, 8, 82},
/*
   pattern 7: 230   connect if invaded
	      102
*/
   {{{0, 0, 2},
     {0, 1, 1},
     {1, 0, 3},
     {1, 1, EMPTY},
     {2, 0, EMPTY},
     {2, 1, 2}}, 6, 8, 82},
/*
   pattern 8: 200000
	       00030  extend
	       00000
*/
   {{{0, 0, 2},
     {1, 0, EMPTY},
     {2, 0, EMPTY},
     {3, 0, EMPTY},
     {4, 0, EMPTY},
     {5, 0, EMPTY},
     {1, 1, EMPTY},
     {2, 1, EMPTY},
     {3, 1, EMPTY},
     {4, 1, 3},
     {5, 1, EMPTY},
     {1, 2, EMPTY},
     {2, 2, EMPTY},
     {3, 2, EMPTY},
     {4, 2, EMPTY},
     {5, 2, EMPTY}}, 16, 8, 80},
/*
   pattern 9:  2
	      000
	      000  extend
	      000
	      030
	      000
*/
   {{{ 0, 0, 2},
     {-1, 1, EMPTY},
     { 0, 1, EMPTY},
     { 1, 1, EMPTY},
     {-1, 2, EMPTY},
     { 0, 2, EMPTY},
     { 1, 2, EMPTY},
     {-1, 3, EMPTY},
     { 0, 3, EMPTY},
     { 1, 3, EMPTY},
     {-1, 4, EMPTY},
     { 0, 4, 3},
     { 1, 4, EMPTY},
     {-1, 5, EMPTY},
     { 0, 5, EMPTY},
     { 1, 5, EMPTY}}, 16, 4, 80},
/*
   pattern 10: 20000
		0030  extend
		0000
*/
   {{{0, 0, 2},
     {1, 0, EMPTY},
     {2, 0, EMPTY},
     {3, 0, EMPTY},
     {4, 0, EMPTY},
     {1, 1, EMPTY},
     {2, 1, EMPTY},
     {3, 1, 3},
     {4, 1, EMPTY},
     {1, 2, EMPTY},
     {2, 2, EMPTY},
     {3, 2, EMPTY},
     {4, 2, EMPTY}}, 13, 8, 79},
/*
   pattern 11:	2
	       000
	       000  extend
	       030
	       000
*/
   {{{ 0, 0, 2},
     {-1, 1, EMPTY},
     { 0, 1, EMPTY},
     { 1, 1, EMPTY},
     {-1, 2, EMPTY},
     { 0, 2, EMPTY},
     { 1, 2, EMPTY},
     {-1, 3, EMPTY},
     { 0, 3, 3},
     { 1, 3, EMPTY},
     {-1, 4, EMPTY},
     { 0, 4, EMPTY},
     { 1, 4, EMPTY}}, 13, 4, 79},
/*
   pattern 12: 2000
		030  extend
		000
*/
   {{{0, 0, 2},
     {1, 0, EMPTY},
     {2, 0, EMPTY},
     {3, 0, EMPTY},
     {1, 1, EMPTY},
     {2, 1, 3},
     {3, 1, EMPTY},
     {1, 2, EMPTY},
     {2, 2, EMPTY},
     {3, 2, EMPTY}}, 10, 8, 76},
/*
   pattern 13:	2
	       000  extend
	       030
	       000
*/
   {{{ 0, 0, 2},
     {-1, 1, EMPTY},
     { 0, 1, EMPTY},
     { 1, 1, EMPTY},
     {-1, 2, EMPTY},
     { 0, 2, 3},
     { 1, 2, EMPTY},
     {-1, 3, EMPTY},
     { 0, 3, EMPTY},
     { 1, 3, EMPTY}}, 10, 4, 76},
/*
   pattern 14: 643   form eye on the edge
		20
*/
   {{{0, 0, 6},
     {1, 0, 4},
     {1, 1, 2},
     {2, 0, 3},
     {2, 1, EMPTY}}, 5, 8, 80},
/*
   pattern 15: 646    solidify eye on the edge
	       231
*/
   {{{0, 0, 6},
     {1, 0, 4},
     {1, 1, 2},
     {2, 0, 6},
     {2, 1, 3},
     {3, 1, 1}}, 6, 8, 75},
/*
   pattern 16: 646    solidify eye on the edge
		230
		 1
*/
   {{{0, 0, 6},
     {1, 0, 4},
     {1, 1, 2},
     {2, 0, 6},
     {2, 1, 3},
     {2, 2, 1},
     {3, 1, EMPTY}}, 7, 8, 75},
/*
   pattern 17: 646    solidify eye on the edge
		230
		 0
*/
   {{{0, 0, 6},
     {1, 0, 4},
     {1, 1, 2},
     {2, 0, 6},
     {2, 1, 3},
     {2, 2, EMPTY},
     {3, 1, EMPTY}}, 7, 8, 75},
/*
   pattern 18:	2	   form eye on center
	       202
		3
*/
   {{{0, 0, 2},
    {-1, 1, 2},
     {0, 1, EMPTY},
     {1, 1, 2},
     {0, 2, 3}}, 5, 4, 80},
/*
   pattern 19:	2	   solidify eye on center
	       202
		231
*/
   {{{0, 0, 2},
    {-1, 1, 2},
     {0, 1, EMPTY},
     {1, 1, 2},
     {0, 2, 2},
     {1, 2, 3},
     {2, 2, 1}}, 7, 8, 75},
/*
   pattern 20:	2	   solidify eye on center
	       202
		230
		 0
*/
   {{{0, 0, 2},
    {-1, 1, 2},
     {0, 1, EMPTY},
     {1, 1, 2},
     {0, 2, 2},
     {1, 2, 3},
     {2, 2, EMPTY},
     {1, 3, EMPTY}}, 8, 8, 75},
/*
   pattern 21:	2	  solidify eye on center
	       202
		230
		 1
*/
   {{{0, 0, 2},
    {-1, 1, 2},
     {0, 1, EMPTY},
     {1, 1, 2},
     {0, 2, 2},
     {1, 2, 3},
     {2, 2, EMPTY},
     {1, 3, 1}}, 8, 8, 75},
/*
   pattern 23: 20100	 connect if invaded
	       00302
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, EMPTY},
     {1, 1, EMPTY},
     {2, 0, 1},
     {2, 1, 3},
     {3, 0, EMPTY},
     {3, 1, EMPTY},
     {4, 0, EMPTY},
     {4, 1, 2}}, 10, 8, 84},
/*
   pattern 24: 2100	connect if invaded
	       0302
*/
   {{{0, 0, 2},
     {0, 1, EMPTY},
     {1, 0, 1},
     {1, 1, 3},
     {2, 0, EMPTY},
     {2, 1, EMPTY},
     {3, 0, EMPTY},
     {3, 1, 2}}, 10, 8, 83}
};
/* end patterns */


/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*-------------------------------------
  count.c -- Count liberty around stone
-------------------------------------*/





void count(int i,     /* row number 0 to 18 */
           int j,     /* column number 0 to 18 */
           int color) /* BLACK or WHITE */
/* count liberty of color piece at location i, j
   and return value in lib */
{
/* set current piece as marked */
 ml[i][j] = EMPTY;

/* check North neighbor */
 if (i != EMPTY)
   {
    if ((p[i - 1][j] == EMPTY) && ml[i - 1][j])
      {
       ++lib;
       ml[i - 1][j] = EMPTY;
     }
    else
       if ((p[i - 1][j] == color) && ml[i - 1][j])
	  count(i - 1, j, color);
  }
/* check South neighbor */
 if (i != 18)
   {
    if ((p[i + 1][j] == EMPTY) && ml[i + 1][j])
      {
       ++lib;
       ml[i + 1][j] = EMPTY;
     }
    else
       if ((p[i + 1][j] == color) && ml[i + 1][j])
	  count(i + 1, j, color);
  }
/* check West neighbor */
 if (j != EMPTY)
   {
    if ((p[i][j - 1] == EMPTY) && ml[i][j - 1])
      {
       ++lib;
       ml[i][j - 1] = EMPTY;
     }
    else
       if ((p[i][j - 1] == color) && ml[i][j - 1])
	  count(i, j - 1, color);
  }
/* check East neighbor */
 if (j != 18)
   {
    if ((p[i][j + 1] == EMPTY) && ml[i][j + 1])
      {
       ++lib;
       ml[i][j + 1] = EMPTY;
     }
    else
       if ((p[i][j + 1] == color) && ml[i][j + 1])
	  count(i, j + 1, color);
  }
}  /* end count */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*--------------------------------------------
  countlib.c -- Count liberty for single stone
--------------------------------------------*/





void countlib(int m,     /* row number 0 to 18 */
              int n,     /* column number 0 to 18 */
              int color) /* BLACK or WHITE */
/* count liberty of color piece at m, n */
{
 int i, j;

/* set all piece as unmarked */
 for (i = 0; i < 19; i++)
   for (j = 0; j < 19; j++)
     ml[i][j] = 1;

/* count liberty of current piece */
 count(m, n, color);
}  /* end countlib */

/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*-----------------------
 endgame.c -- end of game
-----------------------*/




#define BSIZE 19
#define NODES BSIZE*BSIZE
#define ENDLIST 1000
#define QSIZE 150
#define GREY  3


int que[QSIZE],color[BSIZE*BSIZE],listpt[BSIZE*BSIZE];
int *pe, *pstart;
int endq=0;
int queinit=0;
int size=0;

void node2ij(int node,
             int *i,
             int *j)
/* Converts a node number back to an i,j pair. */
{
   *i = node/BSIZE;
   *j = node%BSIZE;
}

int node(int i,
         int j)
{
  return i*BSIZE+j;
}

void createlist(int color,
                int movelist[][5])
/* Create an adjacency list, movelist, for a particular
   color of piece.
*/
{
  int i, j, k;

  for (i=0;i<BSIZE;i++) {
   for (j=0;j<BSIZE;j++) {
     k=0;
     if (p[i][j]==color) {
     /* check up */
       if ( i > 0 ) {
         if (p[i-1][j]==color) {
           movelist[node(i,j)][k]=node(i-1,j);
           k++;
         }
       }
       /* check right */ 
       if ( j < ( BSIZE -1 ) ) { 
         if ( p[i][j+1] == color ) {
           movelist[node(i,j)][k]=node(i,j+1);
           k++;
         }
       }
       /* check down */
       if ( i < ( BSIZE - 1) ) {
         if ( p[i+1][j] == color ) {
           movelist[node(i,j)][k]=node(i+1,j);
           k++;
         }
       }
       /* check left */
       if ( j > 0 ) {
         if ( p[i][j-1]==color ) {
           movelist[node(i,j)][k]=node(i,j-1);
           k++;
         }
       }
     } /* end if for color */
     /* Mark end of adjacency list for this node. */
     movelist[node(i,j)][k]=ENDLIST;
   } /* End j loop */
  } /* End i loop */
}

void enqueue(int *v)
{
  if (queinit == 0)
  {
   pe = que;
   pstart = que;
  }
  *pe = *v;
  pe++;
  size++;
  if ( pe > (que + (QSIZE - 1))) pe = que;
  if (queinit == 0) queinit++;
}

void dequeue(void)
{
 pstart++;
 size--;
 if (pstart > (que + (QSIZE - 1))) pstart = que;
}

int  bfslist(int i,
             int j,
             int movelist[][5],
             int list[])
/* Using the adjacency list, movelist, for pieces of one color
   find all connected points.  
   Starting point is defined by i and j.  Output is
   the number of points found and an array of their 
   locations.
*/
{ 
  int k,u,v;
  int w=0;

  for (k=0;k<(BSIZE*BSIZE);k++) color[k]=WHITE; /* initialization */
  color[node(i,j)] = GREY;
  u=node(i,j);
  enqueue(&u);
#ifdef DEBUG 
printf("Survived first enqueue in bfslist.\n");
#endif
  while (size != 0) {
    k = 0;
    u=*pstart;
    while ((v = movelist[u][k]) != ENDLIST) {    
      if (color[v] == WHITE) {
        color[v] = GREY;
        enqueue(&v);
      }
      k++;
    }
#ifdef DEBUG 
printf("Just prior to first dequeue!.\n");
#endif
    dequeue();
    color[u]=BLACK;
    *(listpt + w) = u;
    w++;
  }
return w;
}

void endgame(void)
/* count pieces and announce the winner */
{
  char an[10];
  int i, j, k, N, mtot, utot, cont;
  int mymovelist[NODES][5];
  int umovelist[NODES][5];

  printf("\nTo count score, we need the following steps:\n");
  printf("First, I need you to remove all dead pieces on the board.\n");
  printf("Second, I need you to fill in neutral territories with ");
  printf("pieces.\n");
  printf("Last, I will fill in all pieces and announce the winner.\n");

/* remove dead pieces */
  printf("\nFirst, you should enter the dead pieces (black and white) to");
  printf(" be removed.  Enter\n");
  printf(" 'stop' when you have finished.\n");

/* Create an adjacency list for the game board. */
/* First a list for the computer's moves */
  createlist(mymove, mymovelist);

/* Then a list for our opponent's moves */
  createlist(umove, umovelist);

  cont = 1;
  do {
      printf("Dead piece? ");
      scanf("%s", an);
      if (strcmp(an, "stop"))
        {
  	 getij(an, &i, &j);
 	 if (p[i][j] == mymove)
 	   {
#ifdef DEBUG 
printf("Just before bfslist.\n");
#endif
 	    N = bfslist(i, j, mymovelist, listpt);
#ifdef DEBUG 
printf("Survived first bfslist.\n");
#endif
 	    for (k=0;k<N;k++)
               {
                node2ij(listpt[k], &i, &j);
                p[i][j] = EMPTY;
                mk++;
               }
 	 }
 	else
 	   if (p[i][j] == umove)
 	     {
#ifdef DEBUG 
printf("Just before second bfslist.\n");
#endif
              N = bfslist(i, j, umovelist, listpt);
              for (k=0;k<N;k++)
                 {
                  node2ij(listpt[k], &i, &j);
                  p[i][j] = EMPTY;
                  uk++;
                 }
       	    }
           showboard();
       }
     else
        cont = 0;
    }
  while (cont);

/* fill in neutral */
  printf("Next, you need to fill in pieces (black and white) in all neutral");
  printf(" territories.\n");
  printf("Enter your and my pieces alternately and");
  printf(" enter 'stop' when finish\n");
  cont = 1;
  N = 0;

  do {
    if ( (N%2) == 0 ) 
     {
      printf("Your piece? ");
      scanf("%s", an);
      if (strcmp(an, "stop"))
        {
 	getij(an, &i, &j);
 	p[i][j] = umove;
 	showboard();
       }
      else
 	cont = 0;
     }
     else
     {
      printf("My piece? ");
      scanf("%s", an);
      if (strcmp(an, "stop"))
        {
 	getij(an, &i, &j);
 	p[i][j] = mymove;
 	showboard();
        }
      else
 	cont = 0;
     }
     N++;
    }
   while (cont);

/* set empty to side they belong to */
   for (i = 0; i < 19; i++)
      for (j = 0; j < 19; j++)
 	if (p[i][j] == EMPTY)
 	   p[i][j] = findcolor(i, j);

/* count total */
  mtot = 0;  utot = 0;
  for (i = 0; i < 19; i++)
     for (j = 0; j < 19; j++)
	if (p[i][j] == mymove)
	  ++mtot;
	else
	   if (p[i][j] == umove)
	     ++utot;

  showboard();
  printf("Your total number of pieces %d\n", utot);
  printf("My total number of pieces %d\n", mtot);

}  /* end endgame */

/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*------------------------------------------------------
  eval.c -- Evaluate liberty of stones in the same color
------------------------------------------------------*/



void eval(int color)  /* BLACK or WHITE */
/* evaluate liberty of color pieces */
 {
  int i, j;

/* find liberty of each piece */
  for (i = 0; i < 19; i++)
    for (j = 0; j < 19; j++)
      if (p[i][j] == color)
	{
	 lib = 0;
	 countlib(i, j, color);
	 l[i][j] = lib;
      }
}  /* end eval */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*--------------------------------------------------------------------
  exambord.c -- Examine board liberty for one color and update results
--------------------------------------------------------------------*/



void examboard(int color) /* BLACK or WHITE */
/* examine pieces */
{
   int i, j, n;

/* find liberty of each piece */
   eval(color);

/* initialize piece captured */
   if (color == mymove)
     {
      mik = -1;
      mjk = -1;
    }
   else
     {
      uik = -1;
      ujk = -1;
    }
   n = 0; /* The number of captures this move for Ko purposes */

/* remove all piece of zero liberty */
   for (i = 0; i < 19; i++)
     for (j = 0; j < 19; j++)
       if ((p[i][j] == color) && (l[i][j] == 0))
	 {
	  p[i][j] = EMPTY;
/* record piece captured */
	  if (color == mymove)
	    {
	     mik = i;
	     mjk = j;
	     ++mk;
	   }
	  else
	    {
	     uik = i;
	     ujk = j;
	     ++uk;
	   }
	  ++n;  /* increment number of captures on this move */
	}
/* reset to -1 if more than one stone captured since  no Ko possible */
   if (color == mymove && n > 1)
     {
       mik = -1;   
       mjk = -1;
     }
   else if ( n > 1 )
     {
       uik = -1;
       ujk = -1;
     }
}  /* end examboard */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*------------------------------------------
  findcolr.c -- Find color of empty location
------------------------------------------*/



unsigned int findcolor(int i,   /* row number 0 to 18 */
                       int j)   /* column number 0 to 18 */
/* find color for empty piece */
{
   int k, result=0, color[4];

/*
 * return color if all four neighbors are the same or empty
 */

if (p[i][j] != EMPTY) return p[i][j];


/* check North neighbor */
   if (i>0) {  /* The if prevents reading off edge of board. */
     k = i;
     do --k;
     while ((p[k][j] == EMPTY) && (k > 0));
     color[0] = p[k][j];
   }
   else color[0] = p[i][j];

/* check South neighbor */
   
   if (i<18) {
     k = i;
     do ++k;
     while ((p[k][j] == EMPTY) && (k < 18));
     color[1] = p[k][j];
   }
   else color[1] = p[i][j];

/* check West neighbor */
   if (j>0) {
     k = j;
     do --k;
     while ((p[i][k] == EMPTY) && (k > 0));
     color[2] = p[i][k];
   }
   else color[2] = p[i][j];

/* check East neighbor */
   if (j<18) {
     k = j;
     do ++k;
     while ((p[i][k] == EMPTY) && (k < 18));
     color[3] = p[i][k];
   }
   else color[3] = p[i][j];

/* Any nonEMPTY color is what we want */

   for (k=0;k<4;k++) {
     if (color[k] == EMPTY) continue;
        else {
          result = color[k];
          break;
        }
   }

/* We know the right color.  Now cross check it.*/
/* If we find an error then all the dead pieces were not taken 
   from the board and we need to prompt the players to fix this. */

  for (k=0;k<4;k++) {
/* If this next test fails, results are inconsistent.  Problem. */
     if ((color[k] != EMPTY) && (color[k] != result)) return 0;
  }

/* If we get to this point everything checks out OK.  Report results. */

   return result;
}  /* end findcolor */

/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*-----------------------------------------------------------------
  findnext.c -- Find next computer move related to current location
-----------------------------------------------------------------*/



static int fval(int newlib, int minlib);

int findnextmove(int m,       /* current stone row number */
                 int n,       /* current stone column number */
                 int *i,      /* next move row number */
                 int *j,      /* next move column number */
                 int *val,    /* next move value */
                 int minlib)  /* current stone liberty */
/* find new move i, j from group containing m, n */
 {
  int ti, tj, tval;
  int found = 0;

  *i = -1;   *j = -1;	*val = -1;
/* mark current position */
  ma[m][n] = 1;

/* check North neighbor */
  if (m != 0) {
     if (p[m - 1][n] == EMPTY)
      {
       ti = m - 1;
       tj = n;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m - 1][n] == mymove) && !ma[m - 1][n])
	 if (findnextmove(m - 1, n, &ti, &tj, &tval, minlib))
	    found = 1;
  }
  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

/* check South neighbor */
  if (m != 18) {
     if (p[m + 1][n] == EMPTY)
      {
       ti = m + 1;
       tj = n;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m + 1][n] == mymove) && !ma[m + 1][n])
	  if (findnextmove(m + 1, n, &ti, &tj, &tval, minlib))
	     found = 1;
  }
  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

/* check West neighbor */
  if (n != 0) {
     if (p[m][n - 1] == EMPTY)
      {
       ti = m;
       tj = n - 1;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m][n - 1] == mymove) && !ma[m][n - 1])
	  if (findnextmove(m, n - 1, &ti, &tj, &tval, minlib))
	      found = 1;
  }
  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

/* check East neighbor */
  if (n != 18) {
     if (p[m][n + 1] == EMPTY)
      {
       ti = m;
       tj = n + 1;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m][n + 1] == mymove) && !ma[m][n + 1])
	  if (findnextmove(m, n + 1, &ti, &tj, &tval, minlib))
	      found = 1;
  }
  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

 if (*val > 0)	/* found next move */
    return 1;
 else	/* next move failed */
    return 0;
}  /* end findnextmove */

int fval(int newlib,   /* new liberty */
         int minlib)   /* current liberty */
/* evaluate function for new move */
{
 int k, val;

 if (newlib <= minlib)
    val = -1;
 else
   {
    k = newlib - minlib;
    val = 40 + (k - 1) * 50 / (minlib * minlib * minlib);
  }
 return val;
}  /* end fval */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*-------------------------------------------------------
  findopen.c -- Find possible moves from current location
-------------------------------------------------------*/



int findopen(int m,      /* current row number 0 to 18 */
             int n,      /* current column number 0 to 18 */
             int i[],    /* row array for possible moves */
             int j[],    /* column array for possible moves */
             int color,  /* BLACK or WHITE */
             int minlib, /* current liberty */
             int *ct)    /* number of possible moves */
/* find all open spaces i, j from m, n */
{
/* mark this one */
 ma[m][n] = 1;

/* check North neighbor */
 if (m != 0)
   {
    if ((p[m - 1][n] == EMPTY) && (((m - 1) != mik) || (n != mjk)))
      {
       i[*ct] = m - 1;
       j[*ct] = n;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m - 1][n] == color) && !ma[m - 1][n])
	 if (findopen(m - 1, n, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* check South neighbor */
 if (m != 18)
   {
    if ((p[m + 1][n] == EMPTY) && (((m + 1) != mik) || (n != mjk)))
      {
       i[*ct] = m + 1;
       j[*ct] = n;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m + 1][n] == color) && !ma[m + 1][n])
	 if (findopen(m + 1, n, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* check West neighbor */
 if (n != 0)
   {
    if ((p[m][n - 1] == EMPTY) && ((m != mik) || ((n - 1) != mjk)))
      {
       i[*ct] = m;
       j[*ct] = n - 1;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m][n - 1] == color) && !ma[m][n - 1])
	 if (findopen(m, n - 1, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* check East neighbor */
 if (n != 18)
   {
    if ((p[m][n + 1] == EMPTY) && ((m != mik) || ((n + 1) != mjk)))
      {
       i[*ct] = m;
       j[*ct] = n + 1;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m][n + 1] == color) && !ma[m][n + 1])
	 if (findopen(m, n + 1, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* fail to find open space */
 return 0;
}  /* end findopen */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/

/*----------------------------------------------------------------
  findpatn.c -- Find computer move from opening moves and patterns
----------------------------------------------------------------*/



int findpatn(int *i,    /* row number of next move */
             int *j,    /* column number of next move */
             int *val)  /* value of next move */
/* find pattern to match for next move */
{
 int m, n;
 int ti, tj, tval;
 static int cnd, mtype;  /* game tree node number, move type */
/* mtype = 0, basic; 1, inverted; 2, reflected; 3, inverted & reflected */

/* open game then occupy corners */
 if (opn[4])   /* continue last move */
   {
    opn[4] = 0;  /* clear flag */
    if (opening(i, j, &cnd, mtype)) opn[4] = 1; /* more move then reset flag */
    if (p[*i][*j] == EMPTY)  /* valid move */
      {
       *val = 80;
       return 1;
     }
    else
      opn[4] = 0;
  }

 if (opn[0])   /* Northwest corner */
   {
    opn[0] = 0;  /* clear flag */
    if (openregion(0, 0, 5, 5))
      {
       cnd = 0;
       mtype = 0;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
 }

 if (opn[1])   /* Southwest corner */
   {
    opn[1] = 0;
    if (openregion(13, 0, 18, 5))
      {
       cnd = 0;
       mtype = 1;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
  }

 if (opn[2])   /* Northeast corner */
   {
    opn[2] = 0;
    if (openregion(0, 13, 5, 18))
      {
       cnd = 0;
       mtype = 2;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
  }

 if (opn[3])   /* Northeast corner */
   {
    opn[3] = 0;
    if (openregion(13, 13, 18, 18))
      {
       cnd = 0;
       mtype = 3;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
  }

/* occupy edges */
 if (opn[5])   /* North edge */
   {
    opn[5] = 0;
    if (openregion(0, 6, 4, 11))
      {
       *i = 3;
       *j = 9;
       *val = 80;
       return 1;
     }
  }

 if (opn[6])   /* South edge */
   {
    opn[6] = 0;
    if (openregion(18, 6, 14, 11))
      {
       *i = 15;
       *j = 9;
       *val = 80;
       return 1;
     }
  }

 if (opn[7])   /* West edge */
   {
    opn[7] = 0;
    if (openregion(6, 0, 11, 4))
      {
       *i = 9;
       *j = 3;
       *val = 80;
       return 1;
     }
  }

 if (opn[8])   /* East edge */
   {
    opn[8] = 0;
    if (openregion(6, 18, 11, 14))
      {
       *i = 9;
       *j = 15;
       *val = 80;
       return 1;
     }
  }

 *i = -1;
 *j = -1;
 *val = -1;

/* find local pattern */
 for (m = 0; m < 19; m++)
   for (n = 0; n < 19; n++)
     if ((p[m][n] == mymove) &&
         (matchpat(m, n, &ti, &tj, &tval) && (tval > *val)))
       {
        *val = tval;
        *i = ti;
        *j = tj;
      }
 if (*val > 0)  /* pattern found */
    return 1;
 else  /* no match found */
    return 0;
}  /* end findpatn */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*------------------------------------------------------------------
  findsavr.c -- Find computer next move to defend stones from attack
------------------------------------------------------------------*/



int findsaver(int *i,    /* row number of next move */
              int *j,    /* column number of next move */
              int *val)  /* value of next move */
/* find move if any pieces is threaten */
{
   int m, n, minlib;
   int ti, tj, tval;

   *i = -1;   *j = -1;	 *val = -1;
   for (minlib = 1; minlib < 4; minlib++)
      {
/* count piece with minimum liberty */
       for (m = 0; m < 19; m++)
	 for (n = 0; n < 19; n++)
	   if ((p[m][n] == mymove) && (l[m][n] == minlib))
/* find move to save pieces */
	     {
	      initmark();
	      if (findnextmove(m, n, &ti, &tj, &tval, minlib) && (tval > *val))
		{
		 *val = tval;
		 *i = ti;
		 *j = tj;
	       }
	     }
     }
    if (*val > 0)   /* find move */
       return 1;
    else	    /* move not found */
       return 0;
 }  /* findsaver */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*---------------------------------------------------------------
  findwinr.c -- Find computer next move to attack opponent stones
---------------------------------------------------------------*/



int findwinner(int *i,    /* row number of next move */
               int *j,    /* column number of next move */
               int *val)  /* value of next move */
/* find opponent piece to capture or attack */
{
 int m, n, ti[3], tj[3], tval, ct, u, v, lib1;

 *i = -1;   *j = -1;   *val = -1;

/* find opponent with liberty less than four */
 for (m = 0; m < 19; m++)
   for (n = 0; n < 19; n++)
     if ((p[m][n] == umove) && (l[m][n] < 4))
       {
	ct = 0;
	initmark();
	if (findopen(m, n, ti, tj, umove, l[m][n], &ct))
	  {
	   if (l[m][n] == 1)
	     {
	      if (*val < 120)
		{
		 *val = 120;
		 *i = ti[0];
		 *j = tj[0];
	       }
	    }
	   else
	     for (u = 0; u < (int)l[m][n]; u++)
	       for (v = 0; v < (int)l[m][n]; v++)
		  if (u != v)
		    {
		     lib = 0;
		     countlib(ti[u], tj[u], mymove);
		     if (lib > 0) /* valid move */
		       {
                        lib1 = lib;
			p[ti[u]][tj[u]] = mymove;
		    /* look ahead opponent move */
			lib = 0;
			countlib(ti[v], tj[v], umove);
			if ((lib1 == 1) && (lib > 0))
                          tval = 0;
                        else
                          tval = 120 - 20 * lib;
			if (*val < tval)
			  {
			   *val = tval;
			   *i = ti[u];
			   *j = tj[u];
			 }
			p[ti[u]][tj[u]] = EMPTY;
		      }
		   }
	 }
      }
 if (*val > 0)	/* find move */
    return 1;
 else  /* fail to find winner */
    return 0;
}  /* end findwinner */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*----------------------------------------------
  fioe.c -- Check if current location is own eye
----------------------------------------------*/



int fioe(int i,   /* stone row number 0 to 18 */
         int j)   /* stone column number 0 to 18 */
{
/* check top edge */
 if (i == 0)
   {
    if ((j == 0) && ((p[1][0] == mymove) && (p[0][1] == mymove))) return 1;
    if ((j == 18) && ((p[1][18] == mymove) && (p[0][17] == mymove))) return 1;
    if ((p[1][j] == mymove) &&
	((p[0][j - 1] == mymove) && (p[0][j + 1] == mymove))) return 1;
    else
       return 0;
  }
/* check bottom edge */
 if (i == 18)
   {
    if ((j == 0) && ((p[17][0] == mymove) && (p[18][1] == mymove))) return 1;
    if ((j == 18) && ((p[17][18] == mymove) && (p[18][17] == mymove))) return 1;
    if ((p[17][j] == mymove) &&
	((p[18][j - 1] == mymove) && (p[18][j + 1] == mymove)))
       return 1;
    else
       return 0;
  }
/* check left edge */
 if (j == 0) {
    if ((p[i][1] == mymove) &&
	((p[i - 1] [0] == mymove) && (p[i + 1][0] == mymove)))
       return 1;
    else
       return 0;
 }
/* check right edge */
 if (j == 18) {
    if ((p[i][17] == mymove) &&
	((p[i - 1] [18] == mymove) && (p[i + 1][18] == mymove)))
       return 1;
    else
       return 0;
 }
/* check center pieces */
 if (((p[i][j - 1] == mymove) && (p[i][j + 1] == mymove)) &&
     ((p[i - 1][j] == mymove) && (p[i + 1][j] == mymove)))
    return 1;
 else
    return 0;
}  /* fioe */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*----------------------------------------
  genmove.c -- Generate computer next move
----------------------------------------*/




#define MAXTRY 400

void genmove(int *i,
             int *j)
/* generate computer move */
{
   int ti, tj, tval;
   char a;
   int ii, val;
   int tryi = 0;   /* number of try */

/* initialize move and value */
   *i = -1;  *j = -1;  val = -1;

/* re-evaluate liberty of opponent pieces */
   eval(umove);

/* find opponent piece to capture or attack */
   if (findwinner(&ti, &tj, &tval))
       if (tval > val)
	 {
	  val = tval;
	  *i = ti;
	  *j = tj;
	}

/* save any piece if threaten */
   if (findsaver(&ti, &tj, &tval))
       if (tval > val)
	 {
	  val = tval;
	  *i = ti;
	  *j = tj;
	}

/* try match local play pattern for new move */
   if (findpatn(&ti, &tj, &tval))
       if (tval > val)
	 {
	  val = tval;
	  *i = ti;
	  *j = tj;
	}

/* no urgent move then do random move */
   if (val < 0)
       do {
	   *i = rand() % 19;

/* avoid low line  and center region */
	   if ((*i < 2) || (*i > 16) || ((*i > 5) && (*i < 13)))
	     {
	      *i = rand() % 19;
	      if ((*i < 2) || (*i > 16))
                *i = rand() % 19;
	    }

           *j = rand() % 19;

/* avoid low line and center region */
	   if ((*j < 2) || (*j > 16) || ((*j > 5) && (*j < 13)))
	     {
              *j = rand() % 19;

	      if ((*j < 2) || (*j > 16))
                *j = rand() % 19;

	    }
	    lib = 0;
	    countlib(*i, *j, mymove);
       }
/* avoid illegal move, liberty one or suicide, fill in own eye */
       while ((++tryi < MAXTRY)
	      && ((p[*i][*j] != EMPTY) || (lib < 2) || fioe(*i, *j)));

   if (tryi >= MAXTRY)  /* computer pass */
     {
      pass++;
      printf("I pass.\n");
      *i = -1;
    }
   else   /* find valid move */
     {
      pass = 0;      
      printf("my move: ");
      if (*j < 8)
	 a = *j + 65;
      else
	 a = *j + 66;
      printf("%c", a);
      ii = 19 - *i;
      if (ii < 10)
	 printf("%1d\n", ii);
      else
	 printf("%2d\n", ii);
    }
}  /* end genmove */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*-------------------------------------------
  getij.c -- Get row column from input string
-------------------------------------------*/



int getij(char move[],   /* move string */
          int *i,        /* move row number */
          int *j)        /* move column number */
/* convert string input to i, j coordinate */
{
 int k;

 if ((move[0] >= 'A') && (move[0] <= 'H'))
    *j = move[0] - 'A';
 else
    if ((move[0] >= 'J') && (move[0] <= 'T'))
       *j = move[0] - 'B';
    else
       if ((move[0] >= 'a') && (move[0] <= 'h'))
	  *j = move[0] - 'a';
       else
	  if ((move[0] >= 'j') && (move[0] <= 't'))
	     *j = move[0] - 'b';
	  else
	     return 0;
 k = move[1] - '0';
 if (move[2]) k = k * 10 + move[2] - '0';
 *i = 19 - k;
 if ((*i >= 0) && (*i <= 18))
    return 1;
 else
    return 0;
}  /* end getij */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*---------------------------------------
  getmove.c -- Get opponent input command
---------------------------------------*/



void getmove(char move[],  /* move string */
             int *i,       /* row number of next move */
             int *j)       /* column number of next move */
/* interpret response of human move to board position */
{
   FILE *fp;
   int m, n;

   if (strcmp(move, "stop") == 0)
/* stop game */
      play = 0;
   else
     {
      if (strcmp(move, "save") == 0)
/* save data and stop game */
	{
	 fp = fopen("gnugo.dat", "w");
/* save board configuration */
	 for (m = 0; m < 19; m++)
	   for (n = 0; n < 19; n++)
	       fprintf(fp, "%c", p[m][n]);
/* my color, pieces captured */
         fprintf(fp, "%d %d %d ", mymove, mk, uk);
/* opening pattern flags */
         for (m = 0; m < 9; m++)
           fprintf(fp, "%d ", opn[m]);

	 fclose(fp);
	 play = -1;
       }
      else
	{
	 if (strcmp(move, "pass") == 0)
/* human pass */
	   {
	    pass++;
	    *i = -1;   /* signal pass */
	  }
	 else
	   {
	    pass = 0;
/* move[0] from A to T, move[1] move[2] from 1 to 19 */
/* convert move to coordinate */
	    if (!getij(move, i, j) || (p[*i][*j] != EMPTY) || suicide(*i, *j))
	      {
	       printf("illegal move !\n");
	       printf("your move? ");
	       scanf("%s", move);
	       getmove(move, i, j);
	     }
	 }
       }
    }
}  /* end getmove */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*----------------------------------------
  initmark.c -- initialize working matrix
----------------------------------------*/void initmark(void)
/* initialize all marking with zero */
{
int i, j;

  for (i = 0; i < 19; i++)
    for (j = 0; j < 19; j++)
      ma[i][j] = 0;
}  /* end initmark */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*-----------------------------------
  matchpat.c -- Match pattern moves
-----------------------------------*/




#define abs(x) ((x) < 0 ? -(x) : (x))
#define line(x) (abs(x - 9))

int matchpat(int m,     /* row origin */
             int n,     /* column origin */
             int *i,    /* row number of next move */
             int *j,    /* column number of next move */
             int *val)  /* next move value */
/* match pattern and get next move */
{
/* transformation matrice */
 static int trf [8][2][2] = {
   {{1, 0}, {0, 1}},   /* linear transfomation matrix */
   {{1, 0}, {0, -1}},  /* invert */
   {{0, 1}, {-1, 0}},  /* rotate 90 */
   {{0, -1}, {-1, 0}}, /* rotate 90 and invert */
   {{-1, 0}, {0, 1}},  /* flip left */
   {{-1, 0}, {0, -1}}, /* flip left and invert */
   {{0, 1}, {1, 0}},   /* rotate 90 and flip left */
   {{0, -1}, {1, 0}}   /* rotate 90, flip left and invert */
 };
 int k, my, nx, ll, r, cont;
 int ti=0, tj=0, tval;

 *i = -1;   *j = -1;   *val = -1;
 for (r = 0; r < PATNO; r++)
/* try each pattern */
    for (ll = 0; ll < pat[r].trfno; ll++)
/* try each orientation transformation */
      {
       k = 0;  cont = 1;
       while ((k != pat[r].patlen) && cont)
/* match each point */
	 {
/* transform pattern real coordinate */
	  nx = n + trf[ll][0][0] * pat[r].patn[k].x
		 + trf[ll][0][1] * pat[r].patn[k].y;
	  my = m + trf[ll][1][0] * pat[r].patn[k].x
		 + trf[ll][1][1] * pat[r].patn[k].y;

/* outside the board */
	  if ((my < 0) || ( my > 18) || (nx < 0) || (nx > 18))
	    {
	     cont = 0;
	     break;
	   }
	  switch (pat[r].patn[k].att) {
	  case 0 : if (p[my][nx] == EMPTY)	/* open */
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 1 : if (p[my][nx] == umove)  /* your piece */
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 2 : if (p[my][nx] == mymove)  /* my piece */
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 3 : if (p[my][nx] == EMPTY)	/* open for new move */
		    {
		     lib = 0;
		     countlib(my, nx, mymove);	/* check liberty */
		     if (lib > 1)  /* move o.k. */
		       {
			ti = my;
			tj = nx;
			break;
		       }
		     else
		       {
			cont = 0;
			break;
		      }
		     }
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 4 : if ((p[my][nx] == EMPTY)  /* open on edge */
		       && ((my == 0) || (my == 18) || (nx == 0) || (nx == 18)))
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 5 : if ((p[my][nx] == umove)  /* your piece on edge */
		       && ((my == 0) || (my == 18) || (nx == 0) || (nx == 18)))
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 6 : if ((p[my][nx] == mymove)  /* my piece on edge */
		       && ((my == 0) || (my == 18) || (nx == 0) || (nx == 18)))
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
		 }
	  ++k;
	 }
	 if (cont)   /* match pattern */
	   {
	    tval = pat[r].patwt;
	    if ((r >= 8) && (r <= 13))	/* patterns for expand region */
	      {
	       if (line(ti) > 7)  /* penalty on line 1, 2 */
		  tval--;
	       else
		  if ((line(ti) == 6) || (line(ti) == 7))
		     tval++;	/* reward on line 3, 4 */

	       if (line(tj) > 7)  /* penalty on line 1, 2 */
		  tval--;
	       else
		  if ((line(tj) == 6) || (line(tj) == 7))
		     tval++;	/* reward on line 3, 4 */
	     }
	    if (tval > *val)
	      {
	       *val = tval;
	       *i = ti;
	       *j = tj;
	     }
	  }
      }
 if (*val > 0)	/* pattern matched */
    return 1;
 else  /* match failed */
    return 0;
}  /* end matchpat */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*-----------------------------------
  opening.c -- Select opening moves
-----------------------------------*/




int opening(int *i,
            int *j,
            int *cnd,
            int type)
/* get move for opening from game tree */
{
 struct tnode {
   int i, j, ndct, next[8];
  };

 static struct tnode tree[] = {
  {-1, -1, 8, { 1, 2, 3, 4, 5, 6, 7, 20}},	/* 0 */
  {2, 3, 2, { 8, 9}},
  {2, 4, 1, {10}},
  {3, 2, 2, {11, 12}},
  {3, 3, 6, {14, 15, 16, 17, 18, 19}},
  {3, 4, 1, {10}},  /* 5 */
  {4, 2, 1, {13}},
  {4, 3, 1, {13}},
  {4, 2, 0},
  {4, 3, 0},
  {3, 2, 0},  /* 10 */
  {2, 4, 0},
  {3, 4, 0},
  {2, 3, 0},
  {2, 5, 1, {10}},
  {2, 6, 1, {10}},  /* 15 */
  {3, 5, 1, {10}},
  {5, 2, 1, {13}},
  {5, 3, 1, {13}},
  {6, 2, 1, {13}},
  {2, 2, 0}  /* 20 */
};
int m;

/* get i, j */
 if ((type == 1) || (type == 3))
    *i = 18 - tree[*cnd].i;   /* inverted */
 else
    *i = tree[*cnd].i;
 if ((type == 2) || (type == 3))
    *j = 18 - tree[*cnd].j;   /* reflected */
 else
    *j = tree[*cnd].j;
 if (tree[*cnd].ndct)  /* more move */
   {
    m = rand() % tree[*cnd].ndct;  /* select move */
    *cnd = tree[*cnd].next[m];	/* new	current node */
    return 1;
  }
 else
    return 0;
}  /* end opening */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*--------------------------------------------------
  openregn.c -- Check if rectangular region is open
---------------------------------------------------*/



int openregion(int i1,
               int j1,
               int i2,
               int j2)
/* check if region from i1, j1 to i2, j2 is open */
{
 int minx, maxx, miny, maxy, x, y;

/* exchange upper and lower limits */

 if (i1 < i2)
   {
    miny = i1;
    maxy = i2;
  }
 else
   {
    miny = i2;
    maxy = i1;
  }

 if (j1 < j2)
   {
    minx = j1;
    maxx = j2;
  }
 else
   {
    minx = j2;
    maxx = j1;
  }

/* check for empty region */
 for (y = miny; y <= maxy; y++)
   for (x = minx; x <= maxx; x++)
     if (p[y][x] != EMPTY) return 0;
 return 1;
}  /* end openregion */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*---------------------------------------------------
  sethand.c -- Set up handicap pieces for black side
----------------------------------------------------*/



void sethand(int i)
/* set up handicap pieces */
{
 if (i > 0)
   {
    p[3][3] = BLACK;
    if (i > 1)
      {
       p[15][15] = BLACK;
       if (i > 2)
	 {
	  p[3][15] = BLACK;
	  if (i > 3)
	    {
	     p[15][3] = BLACK;
	     if (i == 5)
		p[9][9] = BLACK;
	     else
		if (i > 5)
		  {
		   p[9][15] = BLACK;
		   p[9][3] = BLACK;
		   if (i == 7)
		      p[9][9] = BLACK;
		   else
		      if (i > 7)
			{
			 p[15][9] = BLACK;
			 p[3][9] = BLACK;
			 if (i > 8)
			 p[9][9] = BLACK;
 			 if (i > 9)
 			   {p[2][2] = 2;
 			    if (i > 10)
 			      {p[16][16] = 2;
 			       if (i > 11)
 				 {p[2][16] = 2;
 				  if (i > 12)
 				    {p[16][2] = 2;
 				     if (i > 13)
 				       {p[6][6] = 2;
 					if (i > 14)
 					  {p[12][12] = 2;
 					   if (i > 15)
 					     {p[6][12] = 2;
 					      if (i > 16)
 						p[12][6] = 2;
 					    }
 					 }
 				      }
 				   }
 				}
 			     }
 			  }
		       }
		 }
	   }
	}
     }
  }
}  /* end sethand */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*-------------------------------------------------------------
  showbord.c -- Show current go board and playing information
-------------------------------------------------------------*/




void showboard(void)
/* show go board */
{
   int i, j, ii;

/* p = 0 for empty ,p = 1 for white piece, p = 2 for black piece */
   printf("   A B C D E F G H J K L M N O P Q R S T\n");
/* row 19 to 17 */
   for (i = 0; i < 3; i++)
     {
      ii = 19 - i;
      printf("%2d",ii);

      for (j = 0; j < 19; j++)
	if (p[i][j] == EMPTY)
	   printf(" -");
	else if (p[i][j] == WHITE)
		printf(" O");
	     else printf(" X");

      printf("%2d",ii);
      printf("\n");
     }
/* row 16 */
   printf("16");

   for (j = 0; j < 3; j++)
     if (p[3][j] == EMPTY)
	printf(" -");
     else if (p[3][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[3][3] == 0)
      printf(" +");
   else if (p[3][3] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 4; j < 9; j++)
     if (p[3][j] == EMPTY)
	printf(" -");
     else if (p[3][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[3][9] == EMPTY)
      printf(" +");
   else if (p[3][9] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 10; j < 15; j++)
     if (p[3][j] == EMPTY)
	printf(" -");
     else if (p[3][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[3][15] == EMPTY)
      printf(" +");
   else if (p[3][15] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 16; j < 19; j++)
     if (p[3][j] == EMPTY)
	printf(" -");
     else if (p[3][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   printf("16");
   if (umove == 1)
      printf("     Your color: White O\n");
   else
      if (umove == 2)
	 printf("     Your color: Black X\n");
      else
	 printf("\n");
/* row 15 to 11 */
   for (i = 4; i < 9; i++)
     {
      ii = 19 - i;
      printf("%2d",ii);

      for (j = 0; j < 19; j++)
	if (p[i][j] == EMPTY)
	   printf(" -");
	else if (p[i][j] == WHITE)
		printf(" O");
	     else printf(" X");

      printf("%2d",ii);
      if (i == 4)
	{
	 if (mymove == 1)
	    printf("     My color:   White O\n");
	 else
	    if (mymove == 2)
	       printf("     My color:   Black X\n");
	    else
	       printf("\n");
       }
      else
	 if (i != 8)
	    printf("\n");
	 else
	    printf("     You have captured %d pieces\n", mk);
     }
/* row 10 */
   printf("10");

   for (j = 0; j < 3; j++)
     if (p[9][j] == EMPTY)
	printf(" -");
     else if (p[9][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[9][3] == EMPTY)
      printf(" +");
   else if (p[9][3] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 4; j < 9; j++)
     if (p[9][j] == EMPTY)
	printf(" -");
     else if (p[9][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[9][9] == EMPTY)
      printf(" +");
   else if (p[9][9] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 10; j < 15; j++)
     if (p[9][j] == EMPTY)
	printf(" -");
     else if (p[9][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[9][15] == EMPTY)
      printf(" +");
   else if (p[9][15] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 16; j < 19; j++)
     if (p[9][j] == EMPTY)
	printf(" -");
     else if (p[9][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   printf("10");
   printf("     I have captured %d pieces\n", uk);
/* row 9 to 5 */
   for (i = 10; i < 15; i++)
     {
      ii = 19 - i;
      printf("%2d",ii);

      for (j = 0; j < 19; j++)
	if (p[i][j] == EMPTY)
	   printf(" -");
	else if (p[i][j] == WHITE)
		printf(" O");
	     else printf(" X");

      printf("%2d",ii);
      printf("\n");
     }
/* row 4 */
   printf(" 4");

   for (j = 0; j < 3; j++)
     if (p[15][j] == EMPTY)
	printf(" -");
     else if (p[15][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[15][3] == EMPTY)
      printf(" +");
   else if (p[15][3] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 4; j < 9; j++)
     if (p[15][j] == EMPTY)
	printf(" -");
     else if (p[15][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[15][9] == EMPTY)
      printf(" +");
   else if (p[15][9] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 10; j < 15; j++)
     if (p[15][j] == EMPTY)
	printf(" -");
     else if (p[15][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   if (p[15][15] == EMPTY)
      printf(" +");
   else if (p[15][15] == WHITE)
	   printf(" O");
	else printf(" X");

   for (j = 16; j < 19; j++)
     if (p[15][j] == EMPTY)
	printf(" -");
     else if (p[15][j] == WHITE)
	     printf(" O");
	  else printf(" X");

   printf(" 4");
   printf("\n");
/* row 3 to 1 */
   for (i = 16; i < 19; i++)
     {
      ii = 19 - i;
      printf("%2d",ii);

      for (j = 0; j < 19; j++)
	if (p[i][j] == EMPTY)
	   printf(" -");
	else if (p[i][j] == WHITE)
		printf(" O");
	     else printf(" X");

      printf("%2d",ii);
      printf("\n");
     }
   printf("   A B C D E F G H J K L M N O P Q R S T\n\n");
 }  /* end showboard */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*----------------------------------------------------------
  showinst.c -- Show instructions at the beginning of game
----------------------------------------------------------*/




void showinst(void)
/* show program instructions */
{
 printf("XOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOX");
 printf("OXOXOXOXOXOX\n");
 printf("O                                                                  ");
 printf("           O\n");
 printf("X                           GNUGO (Previously Hugo)                ");
 printf("           X\n");
 printf("O                           the game of Go (Wei-Chi)               ");
 printf("           O\n");
 printf("X                                                                  ");
 printf("           X\n");
 printf("O                            version 1.2   10-31-95                ");
 printf("           O\n");
 printf("X           Copyright (C) 1989, 1995 Free Software Foundation, Inc.");
 printf("           X\n");
 printf("O                              Author: Man L. Li                   ");
 printf("           O\n");
 printf("X           GNUGO comes with ABSOLUTELY NO WARRANTY; see COPYING fo");
 printf("r          X\n");
 printf("O           detail.   This is free software, and you are welcome to");
 printf("           O\n");
 printf("X           redistribute it; see COPYING for copying conditions.   ");
 printf("           X\n");
 printf("O                                                                  ");
 printf("           O\n");
 printf("X              Please report all bugs, modifications, suggestions  ");
 printf("           X\n");
 printf("O                             to manli@cs.uh.edu                   ");
 printf("           O\n");
 printf("X                                                                  ");
 printf("           X\n");
 printf("OXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXOXO");
 printf("XOXOXOXOXOXO\n");
 printf("\n\n\n\n\n\n\n\nPress return to continue");
 getchar();
 printf("\n\nTo play this game first select number of handicap pieces (0 to");
 printf(" 17) for the\nblack side.  Next choose your color (black or white).");
 printf("  To place your piece,\nenter your move as coordinate on the board");
 printf(" in column and row.  The column\nis from 'A' to 'T'(excluding 'I').");
 printf("  The row is from 1 to 19.\n\nTo pass your move enter 'pass' for");
 printf(" your turn.  After both you and the computer\npassed the game will");
 printf(" end.  To save the board and exit enter 'save'.  The game\nwill");
 printf(" continue the next time you start the program.  To stop the game in");
 printf(" the\nmiddle of play enter 'stop' for your move.  You will be");
 printf(" asked whether you want\nto count the result of the game.  If you");
 printf(" answer 'y' then you need to remove the\nremaining dead pieces and");
 printf(" fill up neutral turf on the board as instructed.\nFinally, the");
 printf(" computer will count all pieces for both side and show the result.\n\n");
}  /* end showinst */

/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*----------------------------------------------
  suicide.c -- Check for opponent illegal move
----------------------------------------------*/



int suicide(int i,
            int j)
/* check for suicide move of opponent at p[i][j] */
{
 int m, n, k;

/* check liberty of new move */
 lib = 0;
 countlib(i, j, umove);
 if (lib == 0)
/* new move is suicide then check if kill my pieces and Ko possibility */
   {
/* assume alive */
    p[i][j] = umove;

/* check my pieces */
    eval(mymove);
    k = 0;

    for (m = 0; m < 19; m++)
      for (n = 0; n < 19; n++)
/* count pieces will be killed */
	if ((p[m][n] == mymove) && !l[m][n]) ++k;

    if ((k == 0) || (k == 1 && ((i == uik) && (j == ujk))))
/* either no effect on my pieces or an illegal Ko take back */
      {
       p[i][j] = EMPTY;   /* restore to open */
       return 1;
      }
    else
/* good move */
      return 0;
   }
 else
/* valid move */
   return 0;
}  /* end suicide */

//jugador = 1 =>umove 2=>mymove
int suicidemio(int i,int j,int jugador)
/* check for suicide move of opponent at p[i][j] */
{
 int m, n, k;

/* check liberty of new move */
 lib = 0;
 if(jugador==1){
 countlib(i, j, umove);
 }else{
 countlib(i, j, mymove);
 }
 if (lib == 0)
/* new move is suicide then check if kill my pieces and Ko possibility */
   {
/* assume alive */
if(jugador==1){
    p[i][j] = umove;
}else{
	p[i][j] =mymove;
}

/* check my pieces */
if(jugador==1){
	eval(mymove);
}else{
	eval(umove);
}
    
    k = 0;

    for (m = 0; m < 19; m++)
      for (n = 0; n < 19; n++)
/* count pieces will be killed */
if(jugador==1){
	if ((p[m][n] == mymove) && !l[m][n]) ++k;
}else{
	if ((p[m][n] == umove) && !l[m][n]) ++k;
}

    if ((k == 0) || (k == 1 && ((i == uik) && (j == ujk))))
/* either no effect on my pieces or an illegal Ko take back */
      {
       p[i][j] = EMPTY;   /* restore to open */
       return 1;
      }
    else
/* good move */
      return 0;
   }
 else
/* valid move */
   return 0;
}  /* end suicide */
